require "import"
import "android.speech.RecognizerIntent"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "com.androlua.*"
import "android.net.Uri"
import "android.content.Intent"
import "java.util.Locale"
import "android.os.Vibrator"
import "android.content.Context"

local spokenText = ""

function saveWords(words)
    spokenText = words
end

function startListening()
    -- Start vibration when listening begins
    local vibrator = this.getSystemService(Context.VIBRATOR_SERVICE)
    vibrator.vibrate(300)  -- Vibrate for 300 milliseconds at the start

    local verbalizationDetected = false

    local recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ne-np") -- Nepali language code
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())

    local speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)

    local speechListener = RecognitionListener{
        onResults = function(results)
            local data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if data ~= nil and data.size() > 0 then
                verbalizationDetected = true
                local recognizedText = data.get(0)

                saveWords(recognizedText)

                local node = service.getEditText()

                if node == nil then
                    -- If no text field found, speak a message
                    this.speak("Text box not found, this tool is developed by Sandeep Ghimire.")
                    return false
                end

                local targetLanguage = "english"
                local defaultLanguage = Locale.getDefault().getLanguage()
                local languageCodes = { ["english"] = "en" }

                local languageCode = languageCodes[targetLanguage]
                if languageCode then
                    local wordsToTranslate = recognizedText
                    local translatedWords = ""

                    local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
                    url = url .. "&tl=" .. languageCode

                    Http.get(url, function(status, result)
                        if status == 200 then
                            translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                            service.insertText(node, translatedWords .. " ")
                            this.speak(translatedWords)
                        end
                    end)
                end
            end

            if not verbalizationDetected then
                -- End vibration if no verbalization detected
                vibrator.vibrate(300)  -- Vibrate for 300 milliseconds at the end
                kill()
                return false
            end
        end,
        onError = function()
            -- End vibration on error
            vibrator.vibrate(300)
            kill()
            return false
        end
    }

    speechRecognizer.setRecognitionListener(speechListener)
    speechRecognizer.startListening(recognizerIntent)
end

startListening()
return true